/** 
 *   FIXME ....
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#include <stdio.h>
#include <unistd.h>

#include "socket_client.h"
#include "iar_bus.h"


int impares(void)
{
	int fd;
	int ret = 1;
	int data;
	struct ib_packet d;

	//fd = call_socket("127.0.0.1", 2021);
	fd = call_socket_local("test");
	ibus_set_addr(fd, 0x7ff);
	ibus_on( fd );

	while(ret > 0){
		ret = read(fd, &d, sizeof(struct ib_packet_head) );
		if( d.h.size > 0) {
			ret = read(fd, &data, sizeof(int) );
			if( data & 0x1 ){
				data++;
				ibus_send_data( fd, &data, sizeof(int));
			}				
		}
	}

	return 0;
}


int pares(void)
{
	int fd;
	int ret = 1;
	int data;
	struct ib_packet d;

	//fd = call_socket("127.0.0.1", 2021);
	fd = call_socket_local("test");
	ibus_set_addr(fd, 0x2);
	ibus_on( fd );

	while(ret > 0){
		ret = read(fd, &d, sizeof(struct ib_packet_head) );
		if( d.h.size > 0) {
			ret = read(fd, &data, sizeof(int) );
			if( !(data & 0x1) ){
				data++;
				//usleep(1);
				ibus_send_data_to( fd, 0x7ff,&data, sizeof(int));
				//ibus_send_data( fd, &data, sizeof(int));
			}				
		}
	}

	return 0;
}

int wait_for( int num)
{
	int fd;
	int ret = 1;
	int data;
	struct ib_packet d;

	//fd = call_socket("127.0.0.1", 2021);
	fd = call_socket_local("test");
	ibus_on( fd );

	while(ret > 0){
		ret = read(fd, &d, sizeof(struct ib_packet_head) );
		if( d.h.size > 0) {
			ret = read(fd, &data, sizeof(int) );
			if( data == num ){
				data++;
				ibus_send_data( fd, &data, sizeof(int));
			}				
		}
	}

	return 0;
}


int main(int argc, const char *argv[]) 
{
	int pid;
	//int i;

	if ( (pid=fork()) == 0 ) {
		iar_bus_start("test");
	}
	sleep(1);
	
	if ( (pid=fork()) == 0 ) {
		pares();
	}
	impares();
	/*
	  for(i=1;i<512;i++){
	  if ( (pid=fork()) == 0 ) {
	  wait_for( i );
	  }
	  }
	  wait_for( i );
	*/

	return 0;
}


